local cfg = {
	char = {
		Nickname = "",
	},
	profile = {
		Appearance = {
			Border = {
				Debuff = {
					Enabled = true,
				},
				Style = {
					edgeFile = [[Interface\ChatFrame\ChatFrameBackground]], -- Pixel Border settings. 
					edgeSize = 1,
				},
			},
			Bars = {
				Health = {
					Texture = "RUF 5",
					Animate = true,
					Color = {
						BaseColor = {25/255, 25/255, 25/255},
						--colorHealth -- Set in Core to true automatically		
						Class = false,
						Disconnected = true,					
						Percentage = true,
						PercentageGradient = {
							1,1,1, -- 0% HP: White
							25/255,25/255,25/255, -- 50% HP: Grey
							25/255,25/255,25/255 -- 100% HP: Grey
						},
						Reaction = false,
						Tapped = true,
					},
					Background = {
						UseBarColor = false, -- Use Bar Color or Custom Color
						CustomColor = {0,0,0}, -- Custom Color Value
						Multiplier = 0.25, -- Reduce Bar Background Color brightness by this multiplier
						Alpha = 0.5,
					},
				},
				Absorb = { 
					Type = 1, -- 1 Health Overlay, 2 Bar  If 1 then use Frame.Bars.Absorb.Alpha      If 2 then use Unit.Player.Bars.Absorb.Position and Order and Alpha
					Texture = "RUF 5",
					Animate = true,
					Color = {
						BaseColor = {1, 1, 0},
						Class = true,
						Reaction = true,
						Alpha = 0.25,
						Multiplier = 1,
					},
					Background = {
						UseBarColor = false,
						CustomColor = {0,0,0},
						Multiplier = 0.25,
						Alpha = 0.5,
					},
				},
				Class = {
					Texture = "RUF 5",
					Animate = true,
					Color = {
						BaseColor = {100/255, 100/255, 100/255},
						Class = false,
						PowerType = true, -- Use Resource's Color					
						Multiplier = 10, -- Make the bars increase in brightness by this multiplier
					},
					Background = {
						UseBarColor = true,
						CustomColor = {0,0,0},
						Multiplier = 0.25,
						Alpha = 0.5,
					},
				},
				Power = {
					Texture = "RUF 5",
					Animate = true,
					Color = {					
						BaseColor = {50/255, 50/255, 50/255},
						Class = false,
						Disconnected = false,
						Percentage = false,					
						PercentageGradient = {
							1,1,1,
							25/255,25/255,25/255,
							25/255,25/255,25/255
						},
						Reaction = false,
						Tapped = false,
						PowerType = true,
					},
					Background = {
						UseBarColor = true,
						CustomColor = {0,0,0},
						Multiplier = 0.25,
						Alpha = 0.5,
					},
				},
			},
			Colors = { 
				UseClassColors = true, -- Use ClassColors Addon
				ClassColors = { -- !ClassColors Addon Overrides these values.
					DEATHKNIGHT = {207/255,55/255,77/255},
					DEMONHUNTER = {207/255,1,0},
					DRUID = {1,131/255,50/255},
					HUNTER = {161/255,186/255,73/255},
					MAGE = {55/255,197/255,1},
					MONK = {0,169/255,138/255},
					PALADIN = {1,99/255,183/255},
					PRIEST = {1,236/255,211/255},
					ROGUE = {1,216/255,0},
					SHAMAN = {0,107/255,195/255},
					WARLOCK = {150/255,119/255,229/255},
					WARRIOR = {187/255,127/255,75/255},
				},
				MiscColors = {
					Tapped = {100/255,100/255,100/255},
					Disconnected = {1,1,1},
				},
				DifficultyColors = {
					[0] = {1,0.1,0.1}, -- Impossible
					[1] = {1,0.5,0.25}, -- Hard
					[2] = {1,0.82,0}, -- Normal
					[3] = {0.25,0.75,0.25}, -- Easy
					[4] = {0.5,0.5,0.5}, -- Trivial
				},
				PowerColors = {
					[0] = {0,158/255,1}, -- Mana
					[1] = {1,0,55/255}, -- Rage
					[2] = {1,128/255,64/255}, -- Focus
					[3] = {1,1,0}, -- Energy
					[4] = {1,245/255,105/255}, -- Combo Points
					[5] = {128/255,128/255,128/255}, -- Runes
					[6] = {0,211/255,1}, -- Runic Power
					[7] = {150/255,119/255,229/255}, -- Soul Shards
					[8] = {77/255,133/255,230/255}, -- Astral Power
					[9] = {242/255,230/255,153/255}, -- Holy Power
					[10] = {0,158/255,1}, -- Alternate Power
					[11] = {0,128/255,1}, -- Maelstrom
					[12] = {0,247/255,202/255}, -- Chi
					[13] = {102/255,0,204/255}, -- Insanity
					[14] = {0,158/255,1}, -- Unused
					[15] = {0,158/255,1}, -- Unused
					[16] = {0,178/255,250/255}, -- Arcane Charges
					[17] = {207/255,1,0}, -- Fury
					[18] = {1,155/255,0}, -- Pain
					[50] = {180/255,0,20/255}, -- Blood Runes
					[51] = {60/255,205/255,1}, -- Frost Runes
					[52] = {145/255,190/255,15/255}, -- Unholy Runes
				},
				ReactionColors = {
					[1] = {199/255,64/255,64/255}, -- Hated
					[2] = {204/255,97/255,71/255}, -- Hostile Also Enemy Players and NPCs
					[3] = {208/255,130/255,78/255}, -- Unfriendly
					[4] = {218/255,197/255,92/255}, -- Neutral
					[5] = {105/255,169/255,102/255}, -- Friendly Also Allied Players
					[6] = {75/255,175/255,75/255}, -- Honored
					[7] = {68/255,159/255,105/255}, -- Revered
					[8] = {62/255,144/255,133/255}, -- Exalted
					[9] = {0/255,153/255,26/255}, -- Paragon
					[10] = {48/255,113/255,191/255}, -- Friendly Pet
				},
			},
			Text = { 
				Class = {
					Font = "RUF",
					Outline = "OUTLINE",
					Case = 1, -- 0,1,2 0 == Default, 1 == Uppercase, 2 == Lowercase
					Color = {
						BaseColor = {1,1,1},
						Class = false,
						Level = false,
						Percentage = false, -- Below 100%
						PercentageAtMax = false,
						PercentageGradient = {
							1,0,0,
							1,1,0,
							0,1,0,
						},
						PowerType = true,
						Reaction = false,					
					},
				},
				Health = {
					Font = "RUF",
					Outline = "OUTLINE",
					Case = 1, -- 0,1,2 0 == Default, 1 == Uppercase, 2 == Lowercase
					Color = {
						BaseColor = {1,1,1},
						Class = true,
						Level = false,
						Percentage = true, -- Below 100%
						PercentageAtMax = false,
						PercentageGradient = {
							1,0,0,
							1,1,0,
							0,1,0,
						},
						PowerType = false,
						Reaction = true,	
					},
				},
				Level = {
					Font = "RUF",
					Outline = "OUTLINE",
					Case = 1, -- 0,1,2 0 == Default, 1 == Uppercase, 2 == Lowercase
					Color = {
						BaseColor = {1,1,1},
						Class = false,
						Level = true,
						Percentage = false, -- Below 100%
						PercentageAtMax = false,
						PercentageGradient = {
							1,0,0,
							1,1,0,
							0,1,0,
						},
						PowerType = false,
						Reaction = false,					
					},
				},
				Power = {
					Font = "RUF",
					Outline = "OUTLINE",
					Case = 1, -- 0,1,2 0 == Default, 1 == Uppercase, 2 == Lowercase
					Color = {
						BaseColor = {1,1,1},
						Class = false,
						Level = false,
						Percentage = false, -- Below 100%
						PercentageAtMax = false,
						PercentageGradient = {
							1,0,0,
							1,1,0,
							0,1,0,
						},
						PowerType = true, -- Always Mana if tag is Raeli:Mana
						Reaction = false,					
					},
				},
				Name = {
					Font = "RUF",
					Outline = "OUTLINE",
					Case = 1, -- 0,1,2 0 == Default, 1 == Uppercase, 2 == Lowercase
					Color = {
						BaseColor = {1,1,1},
						Class = true,
						Level = false,
						Percentage = false, -- Below 100%
						PercentageAtMax = false,
						PercentageGradient = {
							1,0,0,
							1,1,0,
							0,1,0,
						},
						PowerType = false,
						Reaction = true,					
					},
				},
			},
		},
		unit =  {
		},
	},
}

local function LargeLeftUnits()
	local UnitOptions = {
		Enabled = true,
		Frame = {
			RangeFading = {
				Enabled = true,
				Alpha = 0.5,
			},
			Size = {
				Height = 60,
				Width = 300,
			},
			Bars = {
				Health = { -- Doesn't need options. Health Height is Height -2, Position is filling the frame aside from Power bars for the Health BG.
					Fill = "STANDARD",
				},
				Absorb = {
					Enabled = 1,
					Fill = "STANDARD", -- Use Health Fill if Enabled == 1
					Height = 8,
					Position = {
						Anchor = "BOTTOM",
						Order = 1, -- If 2 bars are at bottom, then order determines which comes first (closest to anchor)
					}, 
				},
				Class = { -- Class or Mana on Additional Mana units.
					Enabled = true,
					Fill = "STANDARD", 
					Height = 8,
					Position = {
						Anchor = "TOP",
					},
				},
				Power = { -- Primary Power or Class on Additional Mana units.
					Enabled = 1, -- 0 Hidden, 1 Show above 0, 2 Always Show
					Fill = "STANDARD",
					Height = 8,
					Position = {
						Anchor = "BOTTOM",
						Order = 0,
					},
				},
			},
			Text = {
				Class = {
					Tag = "[Raeli:Mana]",
					Enabled = 0, -- 0,1,2
					Size = 18,
					Position = {
						x = 4,
						y = -18,
						Anchor = "LEFT",
					},
				},
				Health = {
					Tag = "[Raeli:FullHealth]",
					Enabled = true, -- Boolean
					Size = 28,
					Position = {
						x = -4,
						y = 4,
						Anchor = "RIGHT",
					},
				},
				Level = {
					Tag = "[Raeli:Level]",
					Enabled = false, -- Boolean
					Size = 18,
					Position = {
						x = 4,
						y = -18,
						Anchor = "LEFT",
					},
				},
				Power = {
					Tag = "[Raeli:Power]",
					Enabled = 1, -- 0,1,2
					Size = 18,
					Position = {
						x = -4,
						y = -18,
						Anchor = "RIGHT",
					},
				},
				Name = {
					Tag = "[Raeli:UpperName] [Raeli:AFKDND]",
					Enabled = true, -- Boolean
					Size = 21,
					Position = {
						x = 4,
						y = 4,
						Anchor = "LEFT",
					},
				},					
			},
			Icons = {
				PvP = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
				Mark = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
				Leader = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
				Looter = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
				Ready = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
				Resting = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
			},
		},
	}
	return UnitOptions
end

local function MediumLeftUnits()
	local UnitOptions = {
		Enabled = true,
		Frame = {
			RangeFading = {
				Enabled = true,
				Alpha = 0.5,
			},
			Size = {
				Height = 30,
				Width = 300,
			},
			Bars = {
				Health = { -- Doesn't need options. Health Height is Height -2, Position is filling the frame aside from Power bars for the Health BG.
					Fill = "STANDARD",
				},
				Absorb = {
					Enabled = 1,
					Fill = "STANDARD", -- Use Health Fill if Enabled == 1
					Height = 8,
					Position = {
						Anchor = "BOTTOM",
						Order = 1, -- If 2 bars are at bottom, then order determines which comes first (closest to anchor)
					}, 
				},
				Class = { -- Class or Mana on Additional Mana units.
					Enabled = false,
					Fill = "STANDARD", 
					Height = 4,
					Position = {
						Anchor = "TOP",
					},
				},
				Power = { -- Primary Power or Class on Additional Mana units.
					Enabled = 1, -- 0 Hidden, 1 Show above 0, 2 Always Show
					Fill = "STANDARD",
					Height = 4,
					Position = {
						Anchor = "BOTTOM",
						Order = 0,
					},
				},
			},
			Text = {
				Class = {
					Tag = "[Raeli:Mana]",
					Enabled = 0, -- 0,1,2
					Size = 18,
					Position = {
						x = 0,
						y = 0,
						Anchor = "CENTER",
					},
				},
				Health = {
					Tag = "[Raeli:FullHealth]",
					Enabled = true, -- Boolean
					Size = 21,
					Position = {
						x = -4,
						y = 1,
						Anchor = "RIGHT",
					},
				},
				Level = {
					Tag = "[Raeli:Level]",
					Enabled = false, -- Boolean
					Size = 18,
					Position = {
						x = 0,
						y = 0,
						Anchor = "CENTER",
					},
				},
				Power = {
					Tag = "[Raeli:Power]",
					Enabled = 0, -- 0,1,2
					Size = 18,
					Position = {
						x = 0,
						y = 0,
						Anchor = "CENTER",
					},
				},
				Name = {
					Tag = "[Raeli:UpperName] [Raeli:AFKDND]",
					Enabled = true, -- Boolean
					Size = 21,
					Position = {
						x = 4,
						y = 1,
						Anchor = "LEFT",
					},
				},					
			},
			Icons = {
				PvP = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
				Mark = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
				Leader = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
				Looter = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
				Ready = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
				Resting = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
			},
		},
	}
	return UnitOptions
end

local function LargeRightUnits()
	local UnitOptions = {
		Enabled = true,
		Frame = {
			RangeFading = {
				Enabled = true,
				Alpha = 0.5,
			},
			Size = {
				Height = 60,
				Width = 300,
			},
			Bars = {
				Health = { -- Doesn't need options. Health Height is Height -2, Position is filling the frame aside from Power bars for the Health BG.
					Fill = "REVERSE",
				},
				Absorb = {
					Enabled = 1,
					Fill = "REVERSE", -- Use Health Fill if Enabled == 1
					Height = 8,
					Position = {
						Anchor = "BOTTOM",
						Order = 1, -- If 2 bars are at bottom, then order determines which comes first (closest to anchor)
					}, 
				},
				Class = { -- Class or Mana on Additional Mana units.
					Enabled = true,
					Fill = "REVERSE", 
					Height = 8,
					Position = {
						Anchor = "TOP",
					},
				},
				Power = { -- Primary Power or Class on Additional Mana units.
					Enabled = 1, -- 0 Hidden, 1 Show above 0, 2 Always Show
					Fill = "REVERSE",
					Height = 8,
					Position = {
						Anchor = "BOTTOM",
						Order = 0,
					},
				},
			},
			Text = {
				Class = {
					Tag = "[Raeli:Mana]",
					Enabled = 0, -- 0,1,2
					Size = 18,
					Position = {
						x = 4,
						y = -18,
						Anchor = "LEFT",
					},
				},
				Health = {
					Tag = "[Raeli:FullHealth]",
					Enabled = true, -- Boolean
					Size = 28,
					Position = {
						x = 4,
						y = 4,
						Anchor = "LEFT",
					},
				},
				Level = {
					Tag = "[Raeli:Level]",
					Enabled = false, -- Boolean
					Size = 18,
					Position = {
						x = -4,
						y = -18,
						Anchor = "RIGHT",
					},
				},
				Power = {
					Tag = "[Raeli:Power]",
					Enabled = 1, -- 0,1,2
					Size = 18,
					Position = {
						x = 4,
						y = -18,
						Anchor = "LEFT",
					},
				},
				Name = {
					Tag = "[Raeli:AFKDND] [Raeli:UpperName]",
					Enabled = true, -- Boolean
					Size = 21,
					Position = {
						x = -4,
						y = 4,
						Anchor = "RIGHT",
					},
				},					
			},
			Icons = {
				PvP = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
				Mark = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
				Leader = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
				Looter = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
				Ready = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
				Resting = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
			},
		},
	}
	return UnitOptions
end

local function MediumRightUnits()
	local UnitOptions = {
		Enabled = true,
		Frame = {
			RangeFading = {
				Enabled = true,
				Alpha = 0.5,
			},
			Size = {
				Height = 30,
				Width = 300,
			},
			Bars = {
				Health = { -- Doesn't need options. Health Height is Height -2, Position is filling the frame aside from Power bars for the Health BG.
					Fill = "REVERSE",
				},
				Absorb = {
					Enabled = 1,
					Fill = "REVERSE", -- Use Health Fill if Enabled == 1
					Height = 8,
					Position = {
						Anchor = "BOTTOM",
						Order = 1, -- If 2 bars are at bottom, then order determines which comes first (closest to anchor)
					}, 
				},
				Class = { -- Class or Mana on Additional Mana units.
					Enabled = false,
					Fill = "REVERSE", 
					Height = 4,
					Position = {
						Anchor = "TOP",
					},
				},
				Power = { -- Primary Power or Class on Additional Mana units.
					Enabled = 1, -- 0 Hidden, 1 Show above 0, 2 Always Show
					Fill = "REVERSE",
					Height = 4,
					Position = {
						Anchor = "BOTTOM",
						Order = 0,
					},
				},
			},
			Text = {
				Class = {
					Tag = "[Raeli:Mana]",
					Enabled = 0, -- 0,1,2
					Size = 18,
					Position = {
						x = 0,
						y = 0,
						Anchor = "CENTER",
					},
				},
				Health = {
					Tag = "[Raeli:FullHealth]",
					Enabled = true, -- Boolean
					Size = 21,
					Position = {
						x = 4,
						y = 1,
						Anchor = "LEFT",
					},
				},
				Level = {
					Tag = "[Raeli:Level]",
					Enabled = false, -- Boolean
					Size = 18,
					Position = {
						x = 0,
						y = 0,
						Anchor = "CENTER",
					},
				},
				Power = {
					Tag = "[Raeli:Power]",
					Enabled = 0, -- 0,1,2
					Size = 18,
					Position = {
						x = 0,
						y = 0,
						Anchor = "CENTER",
					},
				},
				Name = {
					Tag = "[Raeli:AFKDND] [Raeli:UpperName]",
					Enabled = true, -- Boolean
					Size = 21,
					Position = {
						x = -4,
						y = 1,
						Anchor = "RIGHT",
					},
				},					
			},
			Icons = {
				PvP = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
				Mark = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
				Leader = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
				Looter = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
				Ready = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
				Resting = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
			},
		},
	}
	return UnitOptions
end

local function SmallUnits()
	local UnitOptions = {
		Enabled = true,
		Frame = {
			RangeFading = {
				Enabled = true,
				Alpha = 0.5,
			},
			Size = {
				Height = 30,
				Width = 125,
			},
			Bars = {
				Health = { -- Doesn't need options. Health Height is Height -2, Position is filling the frame aside from Power bars for the Health BG.
					Fill = "STANDARD",
				},
				Absorb = {
					Enabled = 1,
					Fill = "STANDARD", -- Use Health Fill if Enabled == 1
					Height = 8,
					Position = {
						Anchor = "BOTTOM",
						Order = 1, -- If 2 bars are at bottom, then order determines which comes first (closest to anchor)
					}, 
				},
				Class = { -- Class or Mana on Additional Mana units.
					Enabled = false,
					Fill = "STANDARD", 
					Height = 8,
					Position = {
						Anchor = "TOP",
					},
				},
				Power = { -- Primary Power or Class on Additional Mana units.
					Enabled = 1, -- 0 Hidden, 1 Show above 0, 2 Always Show
					Fill = "STANDARD",
					Height = 8,
					Position = {
						Anchor = "BOTTOM",
						Order = 0,
					},
				},
			},
			Text = {
				Class = {
					Tag = "[Raeli:Mana]",
					Enabled = 0, -- 0,1,2
					Size = 18,
					Position = {
						x = 0,
						y = 1,
						Anchor = "CENTER",
					},
				},
				Health = {
					Tag = "[Raeli:FullHealth]",
					Enabled = false, -- Boolean
					Size = 21,
					Position = {
						x = 0,
						y = 1,
						Anchor = "CENTER",
					},
				},
				Level = {
					Tag = "[Raeli:Level]",
					Enabled = false, -- Boolean
					Size = 18,
					Position = {
						x = 0,
						y = 1,
						Anchor = "CENTER",
					},
				},
				Power = {
					Tag = "[Raeli:Power]",
					Enabled = 0, -- 0,1,2
					Size = 18,
					Position = {
						x = 0,
						y = 1,
						Anchor = "CENTER",
					},
				},
				Name = {
					Tag = "[Raeli:UpperName]",
					Enabled = true, -- Boolean
					Size = 21,
					Position = {
						x = 0,
						y = 1,
						Anchor = "CENTER",
					},
				},					
			},
			Icons = {
				PvP = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
				Mark = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
				Leader = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
				Looter = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
				Ready = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
				Resting = {
					Enabled = true,
					Size = 24,
					Position = {
						x,
						y,
						AnchorIcon, -- Icon to Anchor to, if none, anchor to frame
						AnchorTo,
						AnchorFrom,								
					},
				},
			},
		},
	}
	return UnitOptions
end

do
	cfg.profile.unit.player = LargeLeftUnits()
	cfg.profile.unit.focus = LargeLeftUnits()
	cfg.profile.unit.boss = LargeLeftUnits()
	cfg.profile.unit.arena = LargeLeftUnits()

	cfg.profile.unit.pet = MediumLeftUnits()
	cfg.profile.unit.party = MediumLeftUnits()

	cfg.profile.unit.target = LargeRightUnits()

	cfg.profile.unit.targettarget = MediumRightUnits()

	cfg.profile.unit.pettarget = SmallUnits()
	cfg.profile.unit.partytarget = SmallUnits()
	cfg.profile.unit.focustarget = SmallUnits()
	cfg.profile.unit.bosstarget = SmallUnits()
	cfg.profile.unit.arenatarget = SmallUnits()

	cfg.profile.unit.player.Frame.Text.Class.Enabled = 1
	cfg.profile.unit.player.Frame.Position = {
		x = -390,
		y = -200,
		AnchorFrame = "UIParent", -- UIParent
		AnchorTo = "CENTER", -- The area we anchor to on the UIParent
		AnchorFrom = "CENTER", -- The area on the unitframe we anchor from
	}

	cfg.profile.unit.focus.Frame.Position = {
		x = 4,
		y = 160,
		AnchorFrame = 'UIParent',
		AnchorTo = 'LEFT',
		AnchorFrom = 'LEFT',	
	}

	cfg.profile.unit.boss.Frame.Position = {
		x = 0,
		y = -4,
		AnchorFrame = 'oUF_RUF_Focus',
		AnchorTo = "TOPLEFT",
		AnchorFrom = 'BOTTOMLEFT',
	}

	cfg.profile.unit.arena.Frame.Position = {
		x = 0,
		y = -4,
		AnchorFrame = 'oUF_RUF_Focus',
		AnchorTo = "TOPLEFT",
		AnchorFrom = 'BOTTOMLEFT',
	}

	cfg.profile.unit.pet.Frame.Position = {
		x = 0,
		y = -4,
		AnchorFrame = 'oUF_RUF_Player',
		AnchorTo = "BOTTOM",
		AnchorFrom = 'TOP',
	}
	
	cfg.profile.unit.party.Frame.Position = {
		x = 4,
		y = 4,
		AnchorFrame = 'UIParent',
		AnchorTo = "BOTTOMLEFT",
		AnchorFrom = 'BOTTOMLEFT',
	}


	cfg.profile.unit.pettarget.Frame.Position = {
		x = 4,
		y = 0,
		AnchorFrame = 'oUF_RUF_Pet',
		AnchorTo = "BOTTOMRIGHT",
		AnchorFrom = 'BOTTOMLEFT',
	}
	
	cfg.profile.unit.focustarget.Frame.Position = {
		x = 4,
		y = 0,
		AnchorFrame = 'oUF_RUF_Focus',
		AnchorTo = "BOTTOMRIGHT",
		AnchorFrom = 'BOTTOMLEFT',
	}

	cfg.profile.unit.bosstarget.Frame.Position = {
		x = 4,
		y = 0,
		AnchorFrame = 'oUF_RUF_Boss1',
		AnchorTo = "BOTTOMRIGHT",
		AnchorFrom = 'BOTTOMLEFT',
	}
	
	cfg.profile.unit.arenatarget.Frame.Position = {
		x = 4,
		y = 0,
		AnchorFrame = 'oUF_RUF_Arena1',
		AnchorTo = "BOTTOMRIGHT",
		AnchorFrom = 'BOTTOMLEFT',
	}
	
	cfg.profile.unit.partytarget.Frame.Position = {
		x = 4,
		y = 0,
		AnchorFrame = 'oUF_RUF_Party',
		AnchorTo = "BOTTOMRIGHT",
		AnchorFrom = 'BOTTOMLEFT',
	}

	cfg.profile.unit.target.Frame.Position = {
		x = 390,
		y = -200,
		AnchorFrame = 'UIParent',
		AnchorTo = "CENTER",
		AnchorFrom = 'CENTER',
	}


	cfg.profile.unit.targettarget.Frame.Position = {
		x = 0,
		y = -4,
		AnchorFrame = 'oUF_RUF_Target',
		AnchorTo = "BOTTOM",
		AnchorFrom = 'TOP',
	}
end
	
RUF_cfg = cfg
