local RUF = RUF or LibStub("AceAddon-3.0"):GetAddon("RUF")
local L = LibStub("AceLocale-3.0"):GetLocale("RUF")
local LSM = LibStub("LibSharedMedia-3.0")
local _, ns = ...
local oUF = ns.oUF
local _, PlayerClass = UnitClass('player')
local ShouldEnable
local cfg

function RUF:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("RUFDB", RUF_cfg, true) -- Setup Saved Variables
	local LibDualSpec = LibStub('LibDualSpec-1.0')
	LibDualSpec:EnhanceDatabase(self.db, "RUF")
	cfg = self.db.profile
	
	-- Register /RUF command
	self:RegisterChatCommand("RUF", "ChatCommand")

	-- Register Media
	LSM:Register("font", "RUF", [[Interface\Addons\RUF\Media\TGL.ttf]],LSM.LOCALE_BIT_ruRU + LSM.LOCALE_BIT_western)
	LSM:Register("statusbar", "RUF 1", [[Interface\Addons\RUF\Media\Raeli 1.tga]])
	LSM:Register("statusbar", "RUF 2", [[Interface\Addons\RUF\Media\Raeli 2.tga]])
	LSM:Register("statusbar", "RUF 3", [[Interface\Addons\RUF\Media\Raeli 3.tga]])
	LSM:Register("statusbar", "RUF 4", [[Interface\Addons\RUF\Media\Raeli 4.tga]])
	LSM:Register("statusbar", "RUF 5", [[Interface\Addons\RUF\Media\Raeli 5.tga]])

	if not RUF.db.global.Version then
		RUF.db:ResetProfile()
	end
	RUF.db.global.Version = 49



	do -- Register Class Bar Variable Values
		if(PlayerClass == 'MONK') then
			RUF.db.char.ClassPowerID = 12
			RUF.db.char.ClassPowerType = "CHI"
			RUF.db.char.RequireSpec = SPEC_MONK_WINDWALKER
		elseif(PlayerClass == 'PALADIN') then
			RUF.db.char.ClassPowerID = 9
			RUF.db.char.ClassPowerType = "HOLY_POWER"
			RUF.db.char.RequireSpec = SPEC_PALADIN_RETRIBUTION
		elseif(PlayerClass == 'WARLOCK') then
			RUF.db.char.ClassPowerID = 7
			RUF.db.char.ClassPowerType = "SOUL_SHARDS"
		elseif(PlayerClass == 'ROGUE' or PlayerClass == 'DRUID') then
			RUF.db.char.ClassPowerID = 4
			RUF.db.char.ClassPowerType = 'COMBO_POINTS'
			if(PlayerClass == 'DRUID') then
				RUF.db.char.RequireSpell = 5221 -- Shred
			end
		elseif(PlayerClass == 'MAGE') then
			RUF.db.char.ClassPowerID = 16
			RUF.db.char.ClassPowerType = 'ARCANE_CHARGES'
			RUF.db.char.RequireSpec = SPEC_MAGE_ARCANE
		elseif(PlayerClass == 'DEATHKNIGHT') then
			RUF.db.char.ClassPowerID = 5
			RUF.db.char.ClassPowerType = 'RUNES'
		else
			RUF.db.char.ClassPowerID = nil
			RUF.db.char.ClassPowerType = nil
			RUF.db.char.RequireSpec = nil
			RUF.db.char.RequireSpell = nil
		end
	end

	-- Store Unit List in DB for easy reference.
	RUF.db.global.UnitList = {
		[1] = {
			name = "player",
			group = "",
			frame = "oUF_RUF_Player",
			order = 1,
		},
		[2] = {
			name = "pet",
			group = "",
			frame = "oUF_RUF_Pet",
			order = 2,
		},
		[3] = {
			name = "target",
			group = "",
			frame = "oUF_RUF_Target",
			order = 3,
		},
		[4] = {
			name = "targettarget",
			group = "",
			frame = "oUF_RUF_TargetTarget",
			order = 4,
		},
		[5] = {
			name = "focus",
			group = "",
			frame = "oUF_RUF_Focus",
			order = 5,
		},
		[6] = {
			name = "boss1",
			group = "boss",
			frame = "oUF_RUF_Boss1",
		},
		[7] = {
			name = "boss2",
			group = "boss",
			frame = "oUF_RUF_Boss2",
		},
		[8] = {
			name = "boss3",
			group = "boss",
			frame = "oUF_RUF_Boss3",
		},
		[9] = {
			name = "boss4",
			group = "boss",
			frame = "oUF_RUF_Boss4",
		},
		[10] = {
			name = "arena1",
			group = "arena",
			frame = "oUF_RUF_Arena1",
		},
		[11] = {
			name = "arena2",
			group = "arena",
			frame = "oUF_RUF_Arena2",
		},
		[12] = {
			name = "arena3",
			group = "arena",
			frame = "oUF_RUF_Arena3",
		},
		[13] = {
			name = "arena4",
			group = "arena",
			frame = "oUF_RUF_Arena4",
		},
		[14] = {
			name = "arena5",
			group = "arena",
			frame = "oUF_RUF_Arena5",
		},
		[15] = {
			name = "party1",
			group = "party",
			frame = "oUF_RUF_PartyUnitButton1",
		},
		[16] = {
			name = "party2",
			group = "party",
			frame = "oUF_RUF_PartyUnitButton2",
		},
		[17] = {
			name = "party3",
			group = "party",
			frame = "oUF_RUF_PartyUnitButton3",
		},
		[18] = {
			name = "party4",
			group = "party",
			frame = "oUF_RUF_PartyUnitButton4",
		},
		[19] = {
			name = "focustarget",
			group = "",
			frame = "oUF_RUF_FocusTarget",
			order = 5,
		},
		[20] = {
			name = "pettarget",
			group = "",
			frame = "oUF_RUF_PetTarget",
			order = 2,
		},
		[21] = {
			name = "bosstarget1",
			group = "bosstarget",
			frame = "oUF_RUF_BossTarget1",
		},
		[22] = {
			name = "bosstarget2",
			group = "bosstarget",
			frame = "oUF_RUF_BossTarget2",
		},
		[23] = {
			name = "bosstarget3",
			group = "bosstarget",
			frame = "oUF_RUF_Boss3Targe3",
		},
		[24] = {
			name = "bosstarget4",
			group = "bosstarget",
			frame = "oUF_RUF_Boss4Targe4",
		},
		[25] = {
			name = "arenatarget1",
			group = "arenatarget",
			frame = "oUF_RUF_ArenaTarget1",
		},
		[26] = {
			name = "arenatarget2",
			group = "arenatarget",
			frame = "oUF_RUF_ArenaTarget2",
		},
		[27] = {
			name = "arenatarget3",
			group = "arenatarget",
			frame = "oUF_RUF_ArenaTarget3",
		},
		[28] = {
			name = "arenatarget4",
			group = "arenatarget",
			frame = "oUF_RUF_ArenaTarget4",
		},
		[29] = {
			name = "arenatarget5",
			group = "arenatarget",
			frame = "oUF_RUF_ArenaTarget5",
		},
		[30] = {
			name = "partytarget1",
			group = "partytarget",
			frame = "oUF_RUF_PartyTarget1",
		},
		[31] = {
			name = "partytarget2",
			group = "partytarget",
			frame = "oUF_RUF_PartyTarget2",
		},
		[32] = {
			name = "partytarget3",
			group = "partytarget",
			frame = "oUF_RUF_PartyTarget3",
		},
		[33] = {
			name = "partytarget4",
			group = "partytarget",
			frame = "oUF_RUF_PartyTarget4",
		},
	}
end

local function HealthPostUpdate(element, unit, cur, min, max) -- Not Needed?
	--[[if UnitPlayerControlled(unit) and not UnitCanAttack("target","player") and not UnitIsPlayer(unit) then  -- If the unit is an allied pet then show as blue.
		print(unit)
		element.__owner.colors.reaction[5][1] = cfg.Appearance.Colors.ReactionColors[10][1]
		element.__owner.colors.reaction[5][2] = cfg.Appearance.Colors.ReactionColors[10][2]
		element.__owner.colors.reaction[5][3] = cfg.Appearance.Colors.ReactionColors[10][3]
	else
		element.__owner.colors.reaction[5][1] = cfg.Appearance.Colors.ReactionColors[5][1]
		element.__owner.colors.reaction[5][2] = cfg.Appearance.Colors.ReactionColors[5][2]
		element.__owner.colors.reaction[5][3] = cfg.Appearance.Colors.ReactionColors[5][3]
	end]]--
	element.__owner.Health.colorClass = cfg.Appearance.Bars.Health.Color.Class
	element.__owner.Health.colorDisconnected = cfg.Appearance.Bars.Health.Color.Disconnected
	element.__owner.Health.colorSmooth = cfg.Appearance.Bars.Health.Color.Percentage
	element.__owner.Health.smoothGradient = cfg.Appearance.Bars.Health.Color.PercentageGradient
	element.__owner.Health.colorReaction = cfg.Appearance.Bars.Health.Color.Reaction
	element.__owner.Health.colorTapping = cfg.Appearance.Bars.Health.Color.Tapped
	element.__owner.Health.colorHealth = true
	element.__owner.colors.health = cfg.Appearance.Bars.Health.Color.BaseColor
	element.__owner.Health.Smooth = cfg.Appearance.Bars.Health.Animate
	element.__owner.colors.Tapping = cfg.Appearance.Colors.MiscColors.Tapped
	element.__owner.colors.Disconnected = cfg.Appearance.Colors.MiscColors.Disconnected
	-- TODO: Make Tapping and Disconnected Work
	
	-- TODO:
	-- Update Background Color

	-- Background
	local r,g,b = unpack(cfg.Appearance.Bars.Health.Background.CustomColor)
	local Multiplier = 1
	if cfg.Appearance.Bars.Health.Background.UseBarColor then 
		r,g,b = _G[element.__owner:GetName() .. ".Health.Bar"]:GetStatusBarColor()
		Multiplier = cfg.Appearance.Bars.Health.Background.Multiplier
	end
	
	_G[element.__owner:GetName() .. ".Health.Background"]:SetVertexColor(r*Multiplier,g*Multiplier,b*Multiplier,cfg.Appearance.Bars.Health.Background.Alpha)
end

local function SetHealth(self, unit)
	local Texture = LSM:Fetch("statusbar", cfg.Appearance.Bars.Health.Texture)	
	local Name = self:GetName()
	local Bar = CreateFrame("StatusBar",Name..".Health.Bar",self)
	local Background = Bar:CreateTexture(Name..".Health.Background","BACKGROUND")	
	
	-- Bar
	Bar.colorClass = cfg.Appearance.Bars.Health.Color.Class
	Bar.colorDisconnected = cfg.Appearance.Bars.Health.Color.Disconnected
	Bar.colorSmooth = cfg.Appearance.Bars.Health.Color.Percentage
	Bar.smoothGradient = cfg.Appearance.Bars.Health.Color.PercentageGradient
	Bar.colorReaction = cfg.Appearance.Bars.Health.Color.Reaction
	Bar.colorTapping = cfg.Appearance.Bars.Health.Color.Tapped
	Bar.colorHealth = true -- BaseColor, always enabled, so if none of the other colors match, it falls back to this.
	Bar.Smooth = cfg.Appearance.Bars.Health.Animate
	Bar:SetStatusBarTexture(Texture)
	Bar:SetAllPoints(self)
	Bar:SetFrameLevel(1)
	Bar:SetFillStyle(cfg.unit[unit].Frame.Bars.Health.Fill)

	
	-- Background
	local r,g,b = unpack(cfg.Appearance.Bars.Health.Background.CustomColor)
	local Multiplier = cfg.Appearance.Bars.Health.Background.Multiplier
	Background:SetTexture(LSM:Fetch("background", "Solid"))
	Background:SetVertexColor(r*Multiplier,g*Multiplier,b*Multiplier,cfg.Appearance.Bars.Health.Background.Alpha)
	Background:SetAllPoints(Bar)

	-- Register with oUF
	self.Health = Bar
	--self.Health.bg = Background
end

local function AdditionalPowerUpdate(self, event, unit, ...)
	if unit ~= "player" then return end
	local element = self.AdditionalPower
	if(element.PreUpdate) then element:PreUpdate(unit) end
	local cur = UnitPower('player', 0)
	local max = UnitPowerMax('player', 0)
	element:SetMinMaxValues(0, max)
	element:SetValue(cur)
	if(element.PostUpdate) then
		return element:PostUpdate(unit, cur, max)
	end
end

local function OverrideVisibility(self, event, unit)
	self:RegisterEvent('UNIT_POWER_FREQUENT', AdditionalPowerUpdate)
	self:RegisterEvent('UNIT_MAXPOWER', AdditionalPowerUpdate)
	AdditionalPowerUpdate(self, 'Test', 'player', ADDITIONAL_POWER_BAR_NAME)
end

local function PowerPostUpdate(element, unit, cur, min, max) -- Update ShadowPriest Mana too
	if not unit then return end
	if unit == "vehicle" then return end
	local pType = (select(2,UnitPowerType("player")))
	if RUF:GetSpec() == 1 and element.__owner:GetName() == "oUF_RUF_Player" then -- Correct Class and Player
		if cfg.unit.player.Frame.Bars.Class.Enabled then
			RUF:UpdateElementColor(element,"Power","Power")
			RUF:UpdateElementColor(element,"Class","AdditionalPower")
			local Multiplier = cfg.Appearance.Bars.Class.Background.Multiplier
			local r,g,b = unpack(cfg.Appearance.Colors.PowerColors[0])
			element.__owner.AdditionalPower:SetStatusBarColor(r,g,b)
			element.__owner.AdditionalPower.bg:SetVertexColor(r*Multiplier,g*Multiplier,b*Multiplier,cfg.Appearance.Bars.Class.Background.Alpha)			
			if pType ~= "MANA" then
				-- Show Both bars
				if cfg.unit[unit].Frame.Bars.Class.Enabled then
					RUF:BarVisibility(element, "Power", true)
				else
					RUF:BarVisibility(element, "Power", false)
				end

				if cfg.unit[unit].Frame.Bars.Power.Enabled > 0 then
					RUF:BarVisibility(element, "AdditionalPower", true)
				else
					RUF:BarVisibility(element, "AdditionalPower", false)
				end
			else
				RUF:BarVisibility(element, "Power", false)
				if cfg.unit[unit].Frame.Bars.Power.Enabled > 0 then
					RUF:BarVisibility(element, "AdditionalPower", true)
				else
					RUF:BarVisibility(element, "AdditionalPower", false)
				end
			end
			element.__owner.AdditionalPower:ClearAllPoints()
			element.__owner.AdditionalPower:SetPoint('LEFT',0,0)
			element.__owner.AdditionalPower:SetPoint('RIGHT',0,0)
			element.__owner.Power:ClearAllPoints()
			element.__owner.Power:SetPoint('LEFT',0,0)
			element.__owner.Power:SetPoint('RIGHT',0,0)

			if cfg.unit.player.Frame.Bars.Power.Position.Anchor ~= cfg.unit.player.Frame.Bars.Class.Position.Anchor then
				element.__owner.AdditionalPower:SetPoint(cfg.unit.player.Frame.Bars.Power.Position.Anchor,0,0)-- Move AdditionalPower (Mana)
				element.__owner.AdditionalPower:SetHeight(cfg.unit.player.Frame.Bars.Power.Height)					
				element.__owner.Power:SetPoint(cfg.unit.player.Frame.Bars.Class.Position.Anchor,0,0)-- Move Power (Insanity, Maelstrom)
				element.__owner.Power:SetHeight(cfg.unit.player.Frame.Bars.Class.Height)
			elseif cfg.unit.player.Frame.Bars.Power.Position.Anchor == cfg.unit.player.Frame.Bars.Class.Position.Anchor then
				if cfg.unit.player.Frame.Bars.Power.Position.Order == 0 then
					element.__owner.AdditionalPower:SetPoint(cfg.unit.player.Frame.Bars.Power.Position.Anchor,0,0)-- Move AdditionalPower
					element.__owner.AdditionalPower:SetHeight(cfg.unit.player.Frame.Bars.Power.Height)
					element.__owner.Power:SetHeight(cfg.unit.player.Frame.Bars.Class.Height)
					if element.__owner.AdditionalPower:IsShown() then-- Move Power Offset to AdditionalPower
						if cfg.unit.player.Frame.Bars.Power.Position.Anchor == "TOP" then-- Move down by height of the Mana bar.
							element.__owner.Power:SetPoint(cfg.unit.player.Frame.Bars.Class.Position.Anchor,0,- cfg.unit.player.Frame.Bars.Power.Height +1)
						else-- Move up by height of Mana bar.
							element.__owner.Power:SetPoint(cfg.unit.player.Frame.Bars.Class.Position.Anchor,0,cfg.unit.player.Frame.Bars.Power.Height -1)
						end
					else
						element.__owner.Power:SetPoint(cfg.unit.player.Frame.Bars.Class.Position.Anchor,0,0)
					end
				else
					element.__owner.Power:SetPoint(cfg.unit.player.Frame.Bars.Class.Position.Anchor,0,0)-- Move Power (Insanity, Maelstrom)
					element.__owner.Power:SetHeight(cfg.unit.player.Frame.Bars.Class.Height)
					element.__owner.AdditionalPower:SetHeight(cfg.unit.player.Frame.Bars.Power.Height)-- Move AdditionalPower Offset to Power
					
					if element.__owner.Power:IsShown() then-- Move AdditionalPower Offset to Power
						if cfg.unit.player.Frame.Bars.Power.Position.Anchor == "TOP" then
							element.__owner.AdditionalPower:SetPoint(cfg.unit.player.Frame.Bars.Power.Position.Anchor,0,-cfg.unit.player.Frame.Bars.Class.Height +1)
						else
							element.__owner.AdditionalPower:SetPoint(cfg.unit.player.Frame.Bars.Power.Position.Anchor,0,cfg.unit.player.Frame.Bars.Class.Height -1)
						end
					else
						element.__owner.AdditionalPower:SetPoint(cfg.unit.player.Frame.Bars.Power.Position.Anchor,0,0)
					end
				end
			end
			--RUF:MoveBars(element, unit)
		else
			if element.__owner.AdditionalPower:IsShown() then
				if cfg.unit.player.Frame.Bars.Power.Enabled == 0 then 
					RUF:BarVisibility(element, "AdditionalPower", false)
				end
				RUF:UpdateElementColor(element,"Class","AdditionalPower")
				local Multiplier = cfg.Appearance.Bars.Class.Background.Multiplier
				local r,g,b = unpack(cfg.Appearance.Colors.PowerColors[0])
				element.__owner.AdditionalPower:SetStatusBarColor(r,g,b)
				element.__owner.AdditionalPower.bg:SetVertexColor(r*Multiplier,g*Multiplier,b*Multiplier,cfg.Appearance.Bars.Class.Background.Alpha)
				element.__owner.AdditionalPower:ClearAllPoints()
				element.__owner.AdditionalPower:SetPoint('LEFT',0,0)
				element.__owner.AdditionalPower:SetPoint('RIGHT',0,0)
				element.__owner.AdditionalPower:SetPoint(cfg.unit.player.Frame.Bars.Power.Position.Anchor,0,0)
			end
			RUF:BarVisibility(element, "Power", false)
		end
	elseif RUF:GetSpec() == 2 and element.__owner:GetName() == "oUF_RUF_Player" then
		RUF:BarVisibility(element, "AdditionalPower", false)
		local a,_,_,x,y = element.__owner.Power:GetPoint(3)
		if a ~= cfg.unit.player.Frame.Bars.Power.Position.Anchor then
			element.__owner.Power:ClearAllPoints()
			element.__owner.Power:SetPoint('LEFT',0,0)
			element.__owner.Power:SetPoint('RIGHT',0,0)
			element.__owner.Power:SetPoint(cfg.unit.player.Frame.Bars.Power.Position.Anchor,0,0)
			element.__owner.Power:SetHeight(cfg.unit.player.Frame.Bars.Power.Height)
		end
		RUF:PowerShouldDisplay(element, unit, cur)
	elseif RUF:GetSpec() == 3 and element.__owner:GetName() == "oUF_RUF_Player" then -- Has Class Power but not one of the previous classes.
		-- TODO: Move Class Up or Down.
		RUF:PowerShouldDisplay(element, unit, cur)
		RUF:MoveBars(element, unit)
		--[[if RUF:PowerShouldDisplay(element, unit, cur) == true then
			local a,_,_,x,y = element.__owner.Power:GetPoint(3)
			if a ~= cfg.unit.player.Frame.Bars.Power.Position.Anchor then
				element.__owner.Power:ClearAllPoints()
				element.__owner.Power:SetPoint('LEFT',0,0)
				element.__owner.Power:SetPoint('RIGHT',0,0)
				element.__owner.Power:SetPoint(cfg.unit.player.Frame.Bars.Power.Position.Anchor,0,0)-- Move Power (Insanity, Maelstrom)
				element.__owner.Power:SetHeight(cfg.unit.player.Frame.Bars.Power.Height)
			end
		end]]--
	else
		RUF:PowerShouldDisplay(element, unit, cur)
		RUF:MoveBars(element, unit)
		--[[if RUF:PowerShouldDisplay(element, unit, cur) == true then
			local a,_,_,x,y = element.__owner.Power:GetPoint(3)
			if a ~= cfg.unit[unit].Frame.Bars.Power.Position.Anchor then
				element.__owner.Power:ClearAllPoints()
				element.__owner.Power:SetPoint('LEFT',0,0)
				element.__owner.Power:SetPoint('RIGHT',0,0)
				element.__owner.Power:SetPoint(cfg.unit[unit].Frame.Bars.Power.Position.Anchor,0,0)-- Move Power (Insanity, Maelstrom)
				element.__owner.Power:SetHeight(cfg.unit[unit].Frame.Bars.Power.Height)
			end
		end]]--
	end

	if PlayerClass == "PRIEST" or PlayerClass == "SHAMAN" or PlayerClass == "DRUID" then		
		if pType == "MANA" and element.__owner:GetName() == "oUF_RUF_Player" then 
			element.__owner.TextParent.Power.Text:UpdateTag()
			element.__owner.TextParent.Class:Hide()
		elseif cfg.unit[unit].Frame.Text.Class.Enabled == 2 and element.__owner:GetName() == "oUF_RUF_Player"  then
			element.__owner.TextParent.Power.Text:UpdateTag()
				element.__owner.TextParent.Class:Show()
		elseif cfg.unit[unit].Frame.Text.Class.Enabled == 1 and element.__owner:GetName() == "oUF_RUF_Player"  then
			if UnitPower(unit,0) > 0 then
				element.__owner.TextParent.Power.Text:UpdateTag()
				element.__owner.TextParent.Class:Show()
			else
				element.__owner.TextParent.Power.Text:UpdateTag()
				element.__owner.TextParent.Class:Hide()
			end
		elseif cfg.unit[unit].Frame.Text.Class.Enabled == 0 and element.__owner:GetName() == "oUF_RUF_Player" then
			element.__owner.TextParent.Power.Text:UpdateTag()
			element.__owner.TextParent.Class:Hide()
		end
	end
	-- Show or Hide Power Text
	--[[if cfg.unit[unit].Frame.Text.Power.Enabled == 2 then -- TODO SWAP WITH CLASS TEXT IF NEEDED
		element.__owner.TextParent.Power:Show()
	elseif cfg.unit[unit].Frame.Text.Power.Enabled == 1 and UnitPower(unit) > 0 then
		element.__owner.TextParent.Power:Show()
	else
		element.__owner.TextParent.Power:Hide()
	end]]--

	local r,g,b = RUF:GetPowerColor(element, unit)
	element.__owner.Power:SetStatusBarColor(r,g,b)
	local Multiplier = cfg.Appearance.Bars.Power.Background.Multiplier
	if cfg.Appearance.Bars.Power.Background.UseBarColor == false then
		r,g,b = unpack(cfg.Appearance.Bars.Power.Background.CustomColor)
	end
	element.__owner.Power.bg:SetVertexColor(r*Multiplier,g*Multiplier,b*Multiplier,cfg.Appearance.Bars.Power.Background.Alpha)

	local FrameIndex = RUF:UnitToIndex(unit)
	RUF:UpdateHealthBackground(FrameIndex)
end	

local function SetPower(self, unit) -- Mana, Rage, Insanity, Maelstrom etc.
	local Texture = LSM:Fetch("statusbar", cfg.Appearance.Bars.Power.Texture)	
	local Name = self:GetName()
	local Bar = CreateFrame("StatusBar",Name..".Power.Bar",self)
	local Border = CreateFrame("Frame",Name..".Power.Border",self) --/run print(oUF_RUF_Player.Power:GetParent():GetName())
	local Background = Bar:CreateTexture(Name..".Power.Background","BACKGROUND")	
	
	-- Bar
	Bar.colorClass = cfg.Appearance.Bars.Power.Color.Class
	Bar.colorDisconnected = cfg.Appearance.Bars.Power.Color.Disconnected
	Bar.colorSmooth = cfg.Appearance.Bars.Power.Color.Percentage
	Bar.smoothGradient = cfg.Appearance.Bars.Power.Color.PercentageGradient
	Bar.colorReaction = cfg.Appearance.Bars.Power.Color.Reaction
	Bar.colorTapping = cfg.Appearance.Bars.Power.Color.Tapped
	Bar.colorPower = cfg.Appearance.Bars.Power.Color.PowerType
	Bar.Smooth = cfg.Appearance.Bars.Power.Animate
	Bar:SetStatusBarTexture(Texture)
	Bar:SetFrameLevel(5)
	Bar:SetFillStyle(cfg.unit[unit].Frame.Bars.Power.Fill)
	
	-- Bar Position
	local function SetTopBot()
		if cfg.unit.player.Frame.Bars.Power.Position.Anchor == "TOP" then
			Bar:SetPoint('TOP',0,0)
			Bar:SetPoint('LEFT',0,0)
			Bar:SetPoint('RIGHT',0,0)
			Bar:SetHeight(cfg.unit[unit].Frame.Bars.Power.Height)
		elseif cfg.unit.player.Frame.Bars.Power.Position.Anchor == "BOTTOM" then
			Bar:SetPoint('BOTTOM',0,0)
			Bar:SetPoint('LEFT',0,0)
			Bar:SetPoint('RIGHT',0,0)
			Bar:SetHeight(cfg.unit[unit].Frame.Bars.Power.Height) 		
		end
	end
	if unit == "player" and RUF.db.char.ClassPowerID then
		if cfg.unit.player.Frame.Bars.Class.Position.Anchor == cfg.unit.player.Frame.Bars.Power.Position.Anchor then
			if cfg.unit.player.Frame.Bars.Power.Position.Order == 0 then
				SetTopBot()
			elseif cfg.unit.player.Frame.Bars.Power.Position.Anchor == "TOP" then
				Bar:SetPoint('TOP',0,-cfg.unit[unit].Frame.Bars.Class.Height)
				Bar:SetPoint('LEFT',0,0)
				Bar:SetPoint('RIGHT',0,0)
				Bar:SetHeight(cfg.unit[unit].Frame.Bars.Power.Height)
			elseif cfg.unit.player.Frame.Bars.Power.Position.Anchor == "BOTTOM" then
				Bar:SetPoint('BOTTOM',0,cfg.unit[unit].Frame.Bars.Power.Height)
				Bar:SetPoint('LEFT',0,0)
				Bar:SetPoint('RIGHT',0,0)
				Bar:SetHeight(cfg.unit[unit].Frame.Bars.Power.Height) 		
			end
		else
			SetTopBot()
		end
	else
		SetTopBot()
	end
	
	-- Border
	Border:SetAllPoints(Bar)
	Border:SetFrameLevel(7)
	Border:SetBackdrop(cfg.Appearance.Border.Style)
	Border:SetBackdropBorderColor(0,0,0,1)
	
	-- Background
	local r,g,b = unpack(cfg.Appearance.Bars.Power.Background.CustomColor)
	local Multiplier = cfg.Appearance.Bars.Power.Background.Multiplier
	Background:SetTexture(LSM:Fetch("background", "Solid"))
	Background:SetVertexColor(r*Multiplier,g*Multiplier,b*Multiplier,cfg.Appearance.Bars.Power.Background.Alpha)
	Background:SetAllPoints(Bar)
	Background.colorSmooth = false

	-- Register with oUF
	self.Power = Bar
	self.Power.border = Border
	self.Power.bg = Background	
end

local function SetAdditionalPower(self, unit) -- Mana for Shadow Priests
	local Texture = LSM:Fetch("statusbar", cfg.Appearance.Bars.Class.Texture)	
	local Name = self:GetName()
	local Bar = CreateFrame("StatusBar",Name..".AdditionalPower.Bar",self)
	local Border = CreateFrame("Frame",Name..".AdditionalPower.Border",self) --/run print(oUF_RUF_Player.Class:GetParent():GetName())
	local Background = Bar:CreateTexture(Name..".AdditionalPower.Background","BACKGROUND")	
	
	-- Bar
	Bar.colorClass = cfg.Appearance.Bars.Class.Color.Class
	Bar.colorDisconnected = cfg.Appearance.Bars.Class.Color.Disconnected
	Bar.colorSmooth = cfg.Appearance.Bars.Class.Color.Percentage
	Bar.smoothGradient = cfg.Appearance.Bars.Class.Color.PercentageGradient
	Bar.colorReaction = cfg.Appearance.Bars.Class.Color.Reaction
	Bar.colorTapping = cfg.Appearance.Bars.Class.Color.Tapped
	Bar.colorPower = cfg.Appearance.Bars.Class.Color.PowerType
	Bar.Smooth = cfg.Appearance.Bars.Class.Animate
	Bar:SetStatusBarTexture(Texture)
	Bar:SetFrameLevel(5)
	Bar:SetFillStyle(cfg.unit[unit].Frame.Bars.Class.Fill)
	
	-- Bar Position
	local function SetTopBot()
		if cfg.unit.player.Frame.Bars.Class.Position.Anchor== "TOP" then
			Bar:SetPoint('TOP',0,0)
			Bar:SetPoint('LEFT',0,0)
			Bar:SetPoint('RIGHT',0,0)
			Bar:SetHeight(cfg.unit[unit].Frame.Bars.Class.Height)
		elseif cfg.unit.player.Frame.Bars.Class.Position.Anchor == "BOTTOM" then
			Bar:SetPoint('BOTTOM',0,0)
			Bar:SetPoint('LEFT',0,0)
			Bar:SetPoint('RIGHT',0,0)
			Bar:SetHeight(cfg.unit[unit].Frame.Bars.Class.Height) 		
		end
	end	
	if unit == "player" and cfg.unit.player.Frame.Bars.Power.Position.Enabled then -- Unnecessary because we only generate this on Player.
		if cfg.unit.player.Frame.Bars.Class.Position.Anchor == cfg.unit.player.Frame.Bars.Power.Position.Anchor then
			if cfg.unit.player.Frame.Bars.Power.Position.Order == 1 then
				SetTopBot()
			else
		if cfg.unit.player.Frame.Bars.Class.Position.Anchor == "TOP" then
			Bar:SetPoint('TOP',0,-cfg.unit[unit].Frame.Bars.Class.Height)
			Bar:SetPoint('LEFT',0,0)
			Bar:SetPoint('RIGHT',0,0)
			Bar:SetHeight(cfg.unit[unit].Frame.Bars.Class.Height)
		elseif cfg.unit.player.Frame.Bars.Class.Position.Anchor == "BOTTOM" then
			Bar:SetPoint('BOTTOM',0,cfg.unit[unit].Frame.Bars.Class.Height)
			Bar:SetPoint('LEFT',0,0)
			Bar:SetPoint('RIGHT',0,0)
			Bar:SetHeight(cfg.unit[unit].Frame.Bars.Class.Height) 		
		end
			end
		else
			SetTopBot()
		end
	else
		SetTopBot()
	end
	
	-- Border
	Border:SetAllPoints(Bar)
	Border:SetFrameLevel(7)
	Border:SetBackdrop(cfg.Appearance.Border.Style)
	Border:SetBackdropBorderColor(0,0,0,1)


	-- Background
	local r,g,b = unpack(cfg.Appearance.Bars.Class.Background.CustomColor)
	local Multiplier = cfg.Appearance.Bars.Class.Background.Multiplier
	Background:SetTexture(LSM:Fetch("background", "Solid"))
	Background:SetVertexColor(r*Multiplier,g*Multiplier,b*Multiplier,cfg.Appearance.Bars.Class.Background.Alpha)
	Background:SetAllPoints(Bar)
	Background.colorSmooth = false

	-- Register with oUF
	self.AdditionalPower = Bar
	self.AdditionalPower.border = Border
	self.AdditionalPower.bg = Background

	local _, unitClass = UnitClass(unit)
	if UnitPowerMax(unit, ADDITIONAL_POWER_BAR_INDEX) ~= 0 then
		if(ALT_MANA_BAR_PAIR_DISPLAY_INFO[unitClass]) then
			local powerType = UnitPowerType(unit)
			ShouldEnable = ALT_MANA_BAR_PAIR_DISPLAY_INFO[unitClass][powerType]
		end
	end
	if not ShouldEnable then
		self.AdditionalPower:Hide()
		self.AdditionalPower.border:Hide()
		self.AdditionalPower.bg:Hide()
	end
end

local function ClassPostUpdate(element, cur, max, hasMaxChanged, powerType)
	if not _G[element.__owner:GetName() .. ".Class"]:IsShown() then return end
	local r,g,b = RUF:GetClassColor("player")
	local UnitPowerMaxAmount = UnitPowerMax("player", RUF.db.char.ClassPowerID)			
	local Multiplier = cfg.Appearance.Bars.Class.Background.Multiplier
	local BarMult = cfg.Appearance.Bars.Class.Color.Multiplier
	local Texture = LSM:Fetch("statusbar", cfg.Appearance.Bars.Class.Texture)	

	if PlayerClass == "DEATHKNIGHT" then--and event == "PLAYER_TALENT_UPDATE" then -- Update Bar Colors for Death Knight Specs.
		local Spec = GetSpecialization()
		if Spec == 1 then --Blood
			r,g,b = unpack(cfg.Appearance.Colors.PowerColors[50])
		elseif Spec == 2 then -- Frost
			r,g,b = unpack(cfg.Appearance.Colors.PowerColors[51])
		elseif Spec == 3 then -- Unholy
			r,g,b = unpack(cfg.Appearance.Colors.PowerColors[52])
		else
			r,g,b = unpack(cfg.Appearance.Colors.PowerColors[RUF.db.char.ClassPowerID])
		end
	end

	for index = 1,UnitPowerMaxAmount do
		local ir = r - (r*(((-index + UnitPowerMaxAmount)*BarMult)/100))
		local ig = g - (g*(((-index + UnitPowerMaxAmount)*BarMult)/100))
		local ib = b - (b*(((-index + UnitPowerMaxAmount)*BarMult)/100))
		if cfg.Appearance.Bars.Class.Background.UseBarColor == false then 
			r,g,b = unpack(cfg.Appearance.Bars.Class.Background.CustomColor)
		end
		if PlayerClass == "DEATHKNIGHT" then
			element.__owner.Runes[index]:SetStatusBarTexture(Texture)
			element.__owner.Runes[index]:SetStatusBarColor(ir,ig,ib)
			element.__owner.Runes.bg[index]:SetVertexColor(r*Multiplier,g*Multiplier,b*Multiplier,cfg.Appearance.Bars.Class.Background.Alpha)
		else
			element.__owner.ClassPower[index]:SetStatusBarTexture(Texture)
			element.__owner.ClassPower[index]:SetStatusBarColor(ir,ig,ib)
			element.__owner.ClassPower.bg[index]:SetVertexColor(r*Multiplier,g*Multiplier,b*Multiplier,cfg.Appearance.Bars.Class.Background.Alpha)
		end
	end
end

local function UpdateClassBar(self, event)	
	if (RUF.db.char.ClassPowerID) then -- If we're a class that should show a class bar
		local UnitPowerMaxAmount = UnitPowerMax("player", RUF.db.char.ClassPowerID)
		if cfg.unit.player.Frame.Bars.Class.Enabled == false then
			RUF:BarVisibility(self, "Class", false)	
		elseif(not RUF.db.char.RequireSpec or RUF.db.char.RequireSpec == GetSpecialization()) then -- If the class requires a specific spec, and if so, if we are that spec.
			if(not RUF.db.char.RequireSpell or IsPlayerSpell(RUF.db.char.RequireSpell)) then -- If the class requires a specific spell, druid cat form.
				RUF:BarVisibility(self, "Class", true)				
			else
				RUF:BarVisibility(self, "Class", false)	
			end
		else
			RUF:BarVisibility(self, "Class", false)	
		end
	else
		RUF:BarVisibility(self, "Class", false)
	end
	local FrameIndex = RUF:UnitToIndex(unit)
	RUF:UpdateHealthBackground(FrameIndex)
end

local function SetClassBar(self, unit)
	local ClassPowerBar = {}
	local ClassPowerBorder = {}
	local ClassPowerBG = {}
	if not RUF.db.char.ClassPowerID then return end
	local Name = self:GetName() .. ".Class"
	local UnitPowerMaxAmount = UnitPowerMax(unit, RUF.db.char.ClassPowerID)
	if RUF.db.char.ClassPowerID == 12 then
		UnitPowerMaxAmount = 6
	end
	local GroupParent = CreateFrame("Frame",Name,self) -- For Class Power
	GroupParent:SetPoint("LEFT",self,0,0)
	GroupParent:SetPoint("RIGHT",self,0,0)
	GroupParent:SetPoint("TOP",self,0,0)
	GroupParent:SetPoint("BOTTOM",self,0,0)
	--GroupParent:SetPoint("TOPLEFT",self,0 0)

	--/run _G["oUF_RUF_Player.Class"]:SetPoint("TOPLEFT", oUF_RUF_Player, 0, -60)


	--GroupParent:SetPoint(cfg.unit[unit].Frame.Bars.Class.Position.Anchor,self,cfg.unit[unit].Frame.Bars.Class.Position.Anchor,0,0)
	--GroupParent:SetHeight(cfg.unit[unit].Frame.Bars.Class.Height)
	local Texture = LSM:Fetch("statusbar", cfg.Appearance.Bars.Class.Texture)
	local r,g,b = unpack(cfg.Appearance.Colors.PowerColors[RUF.db.char.ClassPowerID])
	if PlayerClass == "DEATHKNIGHT" then
		local spec = GetSpecialization()
		if spec == 1 then --Blood
			r,g,b = unpack(cfg.Appearance.Colors.PowerColors[50])
		elseif spec == 2 then -- Frost
			r,g,b = unpack(cfg.Appearance.Colors.PowerColors[51])
		elseif spec == 3 then -- Unholy
			r,g,b = unpack(cfg.Appearance.Colors.PowerColors[52])
		else
			r,g,b = unpack(cfg.Appearance.Colors.PowerColors[RUF.db.char.ClassPowerID])
		end
	end
	local Multiplier = cfg.Appearance.Bars.Class.Background.Multiplier
	local Constant = cfg.Appearance.Bars.Class.Color.Multiplier	
	
	for i = 1,UnitPowerMaxAmount do
		local FrameParent = CreateFrame("Frame",Name..i..".Parent",GroupParent)
		local Border = CreateFrame("Frame",Name..i..".Border",FrameParent)
		local Background = FrameParent:CreateTexture(Name..i..".Background","BACKGROUND")
		local Bar = CreateFrame("StatusBar",Name..i..".Bar",FrameParent)
		local Size = (cfg.unit[unit].Frame.Size.Width + (UnitPowerMaxAmount-1)) / UnitPowerMaxAmount
		local Counter = i
		if UnitPowerMaxAmount == 4 then
			Counter = i +1
		end
		
		-- Set Bar Parent Size
		FrameParent:SetWidth(Size)
		FrameParent:SetHeight(cfg.unit[unit].Frame.Bars.Class.Height)
		FrameParent:SetPoint('TOPLEFT', GroupParent, 'TOPLEFT', ((i - 1) * Size - ((i - 1 ) * 1)), 0)
		FrameParent:SetFrameLevel(5)
		
		-- Set Status Bar
		Bar:SetFillStyle(cfg.unit[unit].Frame.Bars.Class.Fill)
		Bar:SetAllPoints(FrameParent)
		Bar:SetFrameLevel(6)		
		Bar:SetStatusBarTexture(Texture)
		local ir = (r*((((Counter+Constant)*6.6667)/100)))
		local ig = (g*((((Counter+Constant)*6.6667)/100)))
		local ib = (b*((((Counter+Constant)*6.6667)/100)))
		Bar:SetStatusBarColor(ir,ig,ib)
		
		-- Set Border
		Border:SetAllPoints(FrameParent)
		Border:SetFrameLevel(7)
		Border:SetBackdrop(cfg.Appearance.Border.Style)
		Border:SetBackdropBorderColor(0,0,0,1)
		
		Background:SetAllPoints(FrameParent)		
		Background:SetTexture(LSM:Fetch("background", "Solid"))
		Background:SetVertexColor(r*Multiplier,g*Multiplier,b*Multiplier,cfg.Appearance.Bars.Class.Background.Alpha)

		ClassPowerBar[i] = Bar
		ClassPowerBorder[i] = Border
		ClassPowerBG[i] = Background		
	end
	
	-- Register with oUF
	if PlayerClass == "DEATHKNIGHT" then
		self.Runes = ClassPowerBar
		self.Runes.border = ClassPowerBorder	
		self.Runes.bg = ClassPowerBG
		self:RegisterEvent('ACTIONBAR_UPDATE_STATE',UpdateClassBar)
		self:RegisterEvent('UNIT_POWER',UpdateClassBar)
		self:RegisterEvent('UNIT_DISPLAYPOWER',UpdateClassBar)
		self:RegisterEvent('PLAYER_ENTERING_WORLD',UpdateClassBar)
	else
		self.ClassPower = ClassPowerBar
		self.ClassPower.border = ClassPowerBorder	
		self.ClassPower.bg = ClassPowerBG
		self:RegisterEvent('PLAYER_TALENT_UPDATE',UpdateClassBar)
		self:RegisterEvent('UNIT_POWER',UpdateClassBar)
		self:RegisterEvent('UNIT_DISPLAYPOWER',UpdateClassBar)
		self:RegisterEvent('PLAYER_ENTERING_WORLD',UpdateClassBar)
	end
	UpdateClassBar(self)	
end

local function AbsorbUpdate(self, event, unit,...)
	if not unit then return end
	if unit == "vehicle" then return end
	if event == "UNIT_TARGET" then
		if unit == "player" then
			if _G[RUF.db.global.UnitList[3].frame] then
				local r,g,b,a = RUF:GetAbsorbColor(RUF.db.global.UnitList[3].name)
				local AbsorbAmount = (UnitGetTotalAbsorbs(RUF.db.global.UnitList[3].name) or 0)
				local max = (UnitHealthMax(RUF.db.global.UnitList[3].name) or 0)
				_G[RUF.db.global.UnitList[3].frame].Absorb:SetMinMaxValues(0, max)
				_G[RUF.db.global.UnitList[3].frame].Absorb:SetValue(AbsorbAmount)
				_G[RUF.db.global.UnitList[3].frame].Absorb:SetStatusBarColor(r,g,b,a)	
			end
			if _G[RUF.db.global.UnitList[4].frame] then
				local r,g,b,a = RUF:GetAbsorbColor(RUF.db.global.UnitList[4].name)
				local AbsorbAmount = (UnitGetTotalAbsorbs(RUF.db.global.UnitList[4].name) or 0)
				local max = (UnitHealthMax(RUF.db.global.UnitList[4].name) or 0)
				_G[RUF.db.global.UnitList[4].frame].Absorb:SetMinMaxValues(0, max)
				_G[RUF.db.global.UnitList[4].frame].Absorb:SetValue(AbsorbAmount)
				_G[RUF.db.global.UnitList[4].frame].Absorb:SetStatusBarColor(r,g,b,a)	
			end
		elseif unit == "target" then
			if _G[RUF.db.global.UnitList[4].frame] then
				local r,g,b,a = RUF:GetAbsorbColor(RUF.db.global.UnitList[4].name)
				local AbsorbAmount = (UnitGetTotalAbsorbs(RUF.db.global.UnitList[4].name) or 0)
				local max = (UnitHealthMax(RUF.db.global.UnitList[4].name) or 0)
				_G[RUF.db.global.UnitList[4].frame].Absorb:SetMinMaxValues(0, max)
				_G[RUF.db.global.UnitList[4].frame].Absorb:SetValue(AbsorbAmount)
				_G[RUF.db.global.UnitList[4].frame].Absorb:SetStatusBarColor(r,g,b,a)	
			end
		else
			for i = 1,#RUF.db.global.UnitList do
				if _G[RUF.db.global.UnitList[i].frame] then
					local r,g,b,a = RUF:GetAbsorbColor(RUF.db.global.UnitList[i].name)
					local AbsorbAmount = (UnitGetTotalAbsorbs(RUF.db.global.UnitList[i].name) or 0)
					local max = (UnitHealthMax(RUF.db.global.UnitList[i].name) or 0)
					_G[RUF.db.global.UnitList[i].frame].Absorb:SetMinMaxValues(0, max)
					_G[RUF.db.global.UnitList[i].frame].Absorb:SetValue(AbsorbAmount)
					_G[RUF.db.global.UnitList[i].frame].Absorb:SetStatusBarColor(r,g,b,a)					
				end
			end			
		end
	elseif event == "UNIT_ABSORB_AMOUNT_CHANGED" then
		if unit == "player" then
			if _G[RUF.db.global.UnitList[1].frame] then
				local r,g,b,a = RUF:GetAbsorbColor(RUF.db.global.UnitList[1].name)
				local AbsorbAmount = (UnitGetTotalAbsorbs(RUF.db.global.UnitList[1].name) or 0)
				local max = (UnitHealthMax(RUF.db.global.UnitList[1].name) or 0)
				_G[RUF.db.global.UnitList[1].frame].Absorb:SetMinMaxValues(0, max)
				_G[RUF.db.global.UnitList[1].frame].Absorb:SetValue(AbsorbAmount)
				_G[RUF.db.global.UnitList[1].frame].Absorb:SetStatusBarColor(r,g,b,a)	
			end
		elseif unit == "target" then
			if _G[RUF.db.global.UnitList[3].frame] then
				local r,g,b,a = RUF:GetAbsorbColor(RUF.db.global.UnitList[3].name)
				local AbsorbAmount = (UnitGetTotalAbsorbs(RUF.db.global.UnitList[3].name) or 0)
				local max = (UnitHealthMax(RUF.db.global.UnitList[3].name) or 0)
				_G[RUF.db.global.UnitList[3].frame].Absorb:SetMinMaxValues(0, max)
				_G[RUF.db.global.UnitList[3].frame].Absorb:SetValue(AbsorbAmount)
				_G[RUF.db.global.UnitList[3].frame].Absorb:SetStatusBarColor(r,g,b,a)	
			end
			if _G[RUF.db.global.UnitList[4].frame] then
				local r,g,b,a = RUF:GetAbsorbColor(RUF.db.global.UnitList[4].name)
				local AbsorbAmount = (UnitGetTotalAbsorbs(RUF.db.global.UnitList[4].name) or 0)
				local max = (UnitHealthMax(RUF.db.global.UnitList[4].name) or 0)
				_G[RUF.db.global.UnitList[4].frame].Absorb:SetMinMaxValues(0, max)
				_G[RUF.db.global.UnitList[4].frame].Absorb:SetValue(AbsorbAmount)
				_G[RUF.db.global.UnitList[4].frame].Absorb:SetStatusBarColor(r,g,b,a)	
			end
		else
			for i = 1,#RUF.db.global.UnitList do
				if _G[RUF.db.global.UnitList[i].frame] then
					local r,g,b,a = RUF:GetAbsorbColor(RUF.db.global.UnitList[i].name)
					local AbsorbAmount = (UnitGetTotalAbsorbs(RUF.db.global.UnitList[i].name) or 0)
					local max = (UnitHealthMax(RUF.db.global.UnitList[i].name) or 0)
					_G[RUF.db.global.UnitList[i].frame].Absorb:SetMinMaxValues(0, max)
					_G[RUF.db.global.UnitList[i].frame].Absorb:SetValue(AbsorbAmount)
					_G[RUF.db.global.UnitList[i].frame].Absorb:SetStatusBarColor(r,g,b,a)					
				end
			end			
		end	
	end
end

local function SetAbsorbBar(self, unit)
	local Texture = LSM:Fetch("statusbar", cfg.Appearance.Bars.Absorb.Texture)	
	local Name = self:GetName()
	local Bar = CreateFrame("StatusBar",Name..".Absorb.Bar",self)
	local Border = CreateFrame("Frame",Name..".Absorb.Border",self)
	local Background = Border:CreateTexture(Name..".Absorb.Background","BACKGROUND")	
	 
	-- Bar
	Bar.colorClass = cfg.Appearance.Bars.Absorb.Color.Class
	Bar.colorDisconnected = cfg.Appearance.Bars.Absorb.Color.Disconnected
	Bar.colorSmooth = cfg.Appearance.Bars.Absorb.Color.Percentage
	Bar.smoothGradient = cfg.Appearance.Bars.Absorb.Color.PercentageGradient
	Bar.colorReaction = cfg.Appearance.Bars.Absorb.Color.Reaction
	Bar.colorTapping = cfg.Appearance.Bars.Absorb.Color.Tapped
	Bar.colorAbsorb = true -- BaseColor, always enabled, so if none of the other colors match, it falls back to this.
	Bar.Smooth = cfg.Appearance.Bars.Absorb.Animate
	Bar:SetStatusBarTexture(Texture)
	if cfg.Appearance.Bars.Absorb.Type == 1 then
		Bar:SetAllPoints(self)
		Border:Hide() -- Hides background too.
	end
	Bar:SetFrameLevel(2)
	Bar:SetFillStyle(cfg.unit[unit].Frame.Bars.Absorb.Fill)
	
	local AbsorbAmount = (UnitGetTotalAbsorbs(unit))
	local r,g,b = unpack(cfg.Appearance.Bars.Absorb.Color.BaseColor)
	local a = cfg.Appearance.Bars.Absorb.Color.Alpha
	local min = 0
	local max = UnitHealthMax(unit)
	Bar:SetMinMaxValues(min, max)
	Bar:SetValue(AbsorbAmount)
	Bar:SetStatusBarColor(r,g,b,a)
	
	-- Border
	Border:SetAllPoints(Bar)
	Border:SetFrameLevel(7)
	Border:SetBackdrop(cfg.Appearance.Border.Style)
	Border:SetBackdropBorderColor(0,0,0,1)
	
	-- Background
	local r,g,b = unpack(cfg.Appearance.Bars.Absorb.Background.CustomColor)
	local Multiplier = cfg.Appearance.Bars.Absorb.Background.Multiplier
	Background:SetTexture(LSM:Fetch("background", "Solid"))	
	Background:SetVertexColor(r*Multiplier,g*Multiplier,b*Multiplier,cfg.Appearance.Bars.Absorb.Background.Alpha)
	Background:SetAllPoints(Bar)
	Background.colorSmooth = false

	-- Register with oUF	
	self.Absorb = Bar
	self.Absorb.border = Border
	self.Absorb.background = Background
	self:RegisterEvent('UNIT_ABSORB_AMOUNT_CHANGED',AbsorbUpdate)
	self:RegisterEvent('UNIT_TARGET',AbsorbUpdate)
	if cfg.Appearance.Bars.Absorb.Type == 0 then
		self.Absorb:Hide()
		self.Absorb.border:Hide()
		self.Absorb.background:Hide()
	end
end

local function SetTextParent(self, unit)
	local TextParent = CreateFrame('Frame', self:GetName() .. ".TextParent", self)
	TextParent:SetFrameLevel(20)
	self.TextParent = TextParent
end

local function SetNameText(self, unit)
	local StringParent = CreateFrame('Frame', self:GetName() .. ".TextParent.Name", self.TextParent)
	StringParent:SetFrameLevel(20)
	self.TextParent.Name = StringParent

	local Text = self.TextParent.Name:CreateFontString(self:GetName() .. ".TextParent.Name.Text", 'OVERLAY', "Raeli")
	Text:SetPoint(cfg.unit[unit].Frame.Text.Name.Position.Anchor, self, cfg.unit[unit].Frame.Text.Name.Position.x, cfg.unit[unit].Frame.Text.Name.Position.y)	
	local Font = LSM:Fetch("font", cfg.Appearance.Text.Name.Font)
	Text:SetFont(Font, cfg.unit[unit].Frame.Text.Name.Size, cfg.Appearance.Text.Name.Outline)
	Text:SetShadowOffset(1, -1)
	Text:SetTextColor(1, 0, 0, 1)
	local AnchorPoint = cfg.unit[unit].Frame.Text.Name.Position.Anchor
	if AnchorPoint == "RIGHT" or AnchorPoint == "TOPRIGHT" or AnchorPoint == "BOTTOMRIGHT" then
		Text:SetJustifyH("RIGHT")
	elseif AnchorPoint == "LEFT" or AnchorPoint == "TOPLEFT" or AnchorPoint == "BOTTOMLEFT" then
		Text:SetJustifyH("LEFT")
	else
		Text:SetJustifyH("CENTER")
	end
	Text:SetWordWrap(false)
	self.TextParent.Name.Text = Text	
	self:Tag(Text, cfg.unit[unit].Frame.Text.Name.Tag)	
end

local function SetHealthText(self, unit)
	local StringParent = CreateFrame('Frame', self:GetName() .. ".TextParent.Health", self.TextParent)
	StringParent:SetFrameLevel(20)
	self.TextParent.Health = StringParent

	local Text = self.TextParent.Health:CreateFontString(self:GetName() .. ".TextParent.Health.Text", 'OVERLAY')
	Text:SetPoint(cfg.unit[unit].Frame.Text.Health.Position.Anchor, self, cfg.unit[unit].Frame.Text.Health.Position.x, cfg.unit[unit].Frame.Text.Health.Position.y)
	local Font = LSM:Fetch("font", cfg.Appearance.Text.Health.Font)
	Text:SetFont(Font, cfg.unit[unit].Frame.Text.Health.Size, cfg.Appearance.Text.Health.Outline)
	Text:SetShadowOffset(1, -1)
	Text:SetTextColor(1, 1, 1, 1)
	local AnchorPoint = cfg.unit[unit].Frame.Text.Health.Position.Anchor
	if AnchorPoint == "RIGHT" or AnchorPoint == "TOPRIGHT" or AnchorPoint == "BOTTOMRIGHT" then
		Text:SetJustifyH("RIGHT")
	elseif AnchorPoint == "LEFT" or AnchorPoint == "TOPLEFT" or AnchorPoint == "BOTTOMLEFT" then
		Text:SetJustifyH("LEFT")
	else
		Text:SetJustifyH("CENTER")
	end
	Text:SetWordWrap(false)
	self.TextParent.Health.Text = Text
	self:Tag(Text, cfg.unit[unit].Frame.Text.Health.Tag)
end

local function SetPowerText(self, unit) -- TODO Frequent Updates
	local StringParent = CreateFrame('Frame', self:GetName() .. ".TextParent.Power", self.TextParent)
	StringParent:SetFrameLevel(20)
	self.TextParent.Power = StringParent

	local Text = self.TextParent.Power:CreateFontString(self:GetName() .. ".TextParent.Power.Text", 'OVERLAY')
	Text:SetPoint(cfg.unit[unit].Frame.Text.Power.Position.Anchor, self, cfg.unit[unit].Frame.Text.Power.Position.x, cfg.unit[unit].Frame.Text.Power.Position.y)
	local Font = ""
	local Font = LSM:Fetch("font", cfg.Appearance.Text.Power.Font)
	Text:SetFont(Font, cfg.unit[unit].Frame.Text.Power.Size, cfg.Appearance.Text.Power.Outline)
	Text:SetShadowOffset(1, -1)
	Text:SetTextColor(1, 1, 1, 1)
	local AnchorPoint = cfg.unit[unit].Frame.Text.Power.Position.Anchor
	if AnchorPoint == "RIGHT" or AnchorPoint == "TOPRIGHT" or AnchorPoint == "BOTTOMRIGHT" then
		Text:SetJustifyH("RIGHT")
	elseif AnchorPoint == "LEFT" or AnchorPoint == "TOPLEFT" or AnchorPoint == "BOTTOMLEFT" then
		Text:SetJustifyH("LEFT")
	else
		Text:SetJustifyH("CENTER")
	end
	Text:SetWordWrap(false)
	self.TextParent.Power.Text = Text
	self:Tag(Text, cfg.unit[unit].Frame.Text.Power.Tag)
end

local function SetAdditionalPowerText(self, unit)
	local StringParent = CreateFrame('Frame', self:GetName() .. ".TextParent.Class", self.TextParent)
	StringParent:SetFrameLevel(20)
	self.TextParent.Class = StringParent

	local Text = self.TextParent.Class:CreateFontString(self:GetName() .. ".TextParent.Class.Text", 'OVERLAY')
	Text:SetPoint(cfg.unit[unit].Frame.Text.Class.Position.Anchor, self, cfg.unit[unit].Frame.Text.Class.Position.x, cfg.unit[unit].Frame.Text.Class.Position.y)
	local Font = ""
	local Font = LSM:Fetch("font", cfg.Appearance.Text.Class.Font)
	Text:SetFont(Font, cfg.unit[unit].Frame.Text.Class.Size, cfg.Appearance.Text.Class.Outline)
	Text:SetShadowOffset(1, -1)
	Text:SetTextColor(1, 1, 1, 1)
	local AnchorPoint = cfg.unit[unit].Frame.Text.Class.Position.Anchor
	if AnchorPoint == "RIGHT" or AnchorPoint == "TOPRIGHT" or AnchorPoint == "BOTTOMRIGHT" then
		Text:SetJustifyH("RIGHT")
	elseif AnchorPoint == "LEFT" or AnchorPoint == "TOPLEFT" or AnchorPoint == "BOTTOMLEFT" then
		Text:SetJustifyH("LEFT")
	else
		Text:SetJustifyH("CENTER")
	end
	Text:SetWordWrap(false)
	self.TextParent.Class.Text = Text
	self:Tag(Text, cfg.unit[unit].Frame.Text.Class.Tag)
end

local function SetLevelText(self, unit) -- DONE
	local StringParent = CreateFrame('Frame', self:GetName() .. ".TextParent.Level", self.TextParent)
	StringParent:SetFrameLevel(20)
	self.TextParent.Level = StringParent

	local Text = self.TextParent.Level:CreateFontString(self:GetName() .. ".TextParent.Level.Text", 'OVERLAY')
	Text:SetPoint(cfg.unit[unit].Frame.Text.Level.Position.Anchor, self, cfg.unit[unit].Frame.Text.Level.Position.x, cfg.unit[unit].Frame.Text.Level.Position.y)
	local Font = ""
	local Font = LSM:Fetch("font", cfg.Appearance.Text.Level.Font)
	Text:SetFont(Font, cfg.unit[unit].Frame.Text.Level.Size, cfg.Appearance.Text.Level.Outline)
	Text:SetShadowOffset(1, -1)
	Text:SetTextColor(1, 1, 1, 1)
	local AnchorPoint = cfg.unit[unit].Frame.Text.Level.Position.Anchor
	if AnchorPoint == "RIGHT" or AnchorPoint == "TOPRIGHT" or AnchorPoint == "BOTTOMRIGHT" then
		Text:SetJustifyH("RIGHT")
	elseif AnchorPoint == "LEFT" or AnchorPoint == "TOPLEFT" or AnchorPoint == "BOTTOMLEFT" then
		Text:SetJustifyH("LEFT")
	else
		Text:SetJustifyH("CENTER")
	end
	Text:SetWordWrap(false)
	self.TextParent.Level.Text = Text
	self:Tag(Text, cfg.unit[unit].Frame.Text.Level.Tag)
end

local function SetClassColors()
	local function customClassColors()
		if(CUSTOM_CLASS_COLORS) and cfg.Appearance.Colors.UseClassColors then
			local function updateColors()
				for classToken, color in next, CUSTOM_CLASS_COLORS do
					cfg.Appearance.Colors.ClassColors[classToken] = {(color.r), (color.g), (color.b)}				
				end
				for _, obj in next, oUF.objects do
					obj:UpdateAllElements('CUSTOM_CLASS_COLORS')
				end
			end
			updateColors()
			CUSTOM_CLASS_COLORS:RegisterCallback(updateColors)
			return true
		end
	end
	if(not customClassColors()) then
		local eventHandler = CreateFrame('Frame')
		eventHandler:RegisterEvent('ADDON_LOADED')
		eventHandler:SetScript('OnEvent', function(self)
			if(customClassColors()) then
				self:UnregisterEvent('ADDON_LOADED')
				self:SetScript('OnEvent', nil)
			end
		end)
	end
end

local function SetupFrames(self, unit)
	unit = unit:match('^(.-)%d+') or unit

	SetClassColors() -- Set Colours
	self.colors.Tapping = cfg.Appearance.Colors.MiscColors.Tapped
	self.colors.Disconnected = cfg.Appearance.Colors.MiscColors.Disconnected
	self.colors.class.DEATHKNIGHT = cfg.Appearance.Colors.ClassColors.DEATHKNIGHT
	self.colors.class.DEMONHUNTER = cfg.Appearance.Colors.ClassColors.DEMONHUNTER
	self.colors.class.DRUID = cfg.Appearance.Colors.ClassColors.DRUID
	self.colors.class.HUNTER = cfg.Appearance.Colors.ClassColors.HUNTER
	self.colors.class.MAGE = cfg.Appearance.Colors.ClassColors.MAGE
	self.colors.class.MONK = cfg.Appearance.Colors.ClassColors.MONK
	self.colors.class.PALADIN = cfg.Appearance.Colors.ClassColors.PALADIN
	self.colors.class.PRIEST = cfg.Appearance.Colors.ClassColors.PRIEST
	self.colors.class.ROGUE = cfg.Appearance.Colors.ClassColors.ROGUE
	self.colors.class.SHAMAN = cfg.Appearance.Colors.ClassColors.SHAMAN
	self.colors.class.WARLOCK = cfg.Appearance.Colors.ClassColors.WARLOCK
	self.colors.class.WARRIOR = cfg.Appearance.Colors.ClassColors.WARRIOR	
	for i = 1,8 do
		self.colors.reaction[i][1] = cfg.Appearance.Colors.ReactionColors[i][1]
		self.colors.reaction[i][2] = cfg.Appearance.Colors.ReactionColors[i][2]
		self.colors.reaction[i][3] = cfg.Appearance.Colors.ReactionColors[i][3]
	end
	--[[if UnitPlayerControlled(unit) and not UnitCanAttack("target","player") and not UnitIsPlayer(unit) then  -- If the unit is an allied pet then show as blue.
		self.colors.reaction[5][1] = cfg.Appearance.Colors.ReactionColors[10][1]
		self.colors.reaction[5][2] = cfg.Appearance.Colors.ReactionColors[10][2]
		self.colors.reaction[5][3] = cfg.Appearance.Colors.ReactionColors[10][3]
	else
		self.colors.reaction[5][1] = cfg.Appearance.Colors.ReactionColors[5][1]
		self.colors.reaction[5][2] = cfg.Appearance.Colors.ReactionColors[5][2]
		self.colors.reaction[5][3] = cfg.Appearance.Colors.ReactionColors[5][3]
	end]]--
	self.colors.health = cfg.Appearance.Bars.Health.Color.BaseColor
	self.colors.power.MANA = cfg.Appearance.Colors.PowerColors[0]
	self.colors.power.RAGE = cfg.Appearance.Colors.PowerColors[1]
	self.colors.power.FOCUS = cfg.Appearance.Colors.PowerColors[2]
	self.colors.power.ENERGY = cfg.Appearance.Colors.PowerColors[3]
	self.colors.power.COMBO_POINTS = cfg.Appearance.Colors.PowerColors[4]
	self.colors.power.RUNES = cfg.Appearance.Colors.PowerColors[5]
	self.colors.power.RUNIC_POWER = cfg.Appearance.Colors.PowerColors[6]
	self.colors.power.SOUL_SHARDS = cfg.Appearance.Colors.PowerColors[7]
	self.colors.power.LUNAR_POWER = cfg.Appearance.Colors.PowerColors[8]
	self.colors.power.HOLY_POWER = cfg.Appearance.Colors.PowerColors[9]
	self.colors.power.MAELSTROM = cfg.Appearance.Colors.PowerColors[11]
	self.colors.power.CHI = cfg.Appearance.Colors.PowerColors[12]
	self.colors.power.INSANITY = cfg.Appearance.Colors.PowerColors[13]
	self.colors.power.ARCANE_CHARGES = cfg.Appearance.Colors.PowerColors[16]
	self.colors.power.FURY = cfg.Appearance.Colors.PowerColors[17]
	self.colors.power.PAIN = cfg.Appearance.Colors.PowerColors[18]

	self.colors.runes[1] = cfg.Appearance.Colors.PowerColors[50]--Blood
	self.colors.runes[2] = cfg.Appearance.Colors.PowerColors[51]--Frost
	self.colors.runes[3] = cfg.Appearance.Colors.PowerColors[52]--Unholy

	RUF:UpdateUnitSettings()
	self:RegisterForClicks('AnyUp')
	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)

	-- Frame Border
	local Border = CreateFrame("Frame",self:GetName()..".Border",self)
	Border:SetAllPoints(self)
	Border:SetFrameLevel(10)
	Border:SetBackdrop(cfg.Appearance.Border.Style)
	Border:SetBackdropBorderColor(0,0,0,1)
	self.border = Border
	self:SetHeight(cfg.unit[unit].Frame.Size.Height)
	self:SetWidth(cfg.unit[unit].Frame.Size.Width)
	self:SetClampedToScreen(true)

	-- Setup Elements
	SetHealth(self, unit) -- Always set this up.
	SetPower(self, unit)
	SetTextParent(self, unit)
	SetNameText(self, unit)
	SetHealthText(self, unit)
	SetPowerText(self, unit)
	SetLevelText(self, unit)

	self.Power.PostUpdate = PowerPostUpdate
	self.Health.PostUpdate = HealthPostUpdate
	
	if (unit == 'player') then -- Only setup on player target.
		self.Power.frequentUpdates = true
		if PlayerClass == "PRIEST" or PlayerClass == "SHAMAN" or PlayerClass == "DRUID" then
			SetAdditionalPower(self, unit)
			self.AdditionalPower.PostUpdate = PowerPostUpdate
			self.AdditionalPower.OverrideVisibility = OverrideVisibility
			SetAdditionalPowerText(self, unit)			
		elseif RUF.db.char.ClassPowerID then	
			SetClassBar(self, unit)
			if PlayerClass == "DEATHKNIGHT" then
				self.Runes.PostUpdate = ClassPostUpdate
			else
				self.ClassPower.PostUpdate = ClassPostUpdate
			end
		end
	end
	if unit == 'targettarget' then
		self.onUpdateFrequency	= 1-- TODO Option
	else
		self.onUpdateFrequency	= 1
	end
	if cfg.Appearance.Bars.Absorb.Type == 1 then -- To do. Setup Bar overlay over Healthbar
		SetAbsorbBar(self, unit)
	elseif cfg.Appearance.Bars.Absorb.Type == 2 then -- To do. Setup Bar as separate bar.
		-- SetAbsorbBar(self, unit)
	end


	if cfg.unit[unit].Frame.Text.Name.Enabled == false then
		self.TextParent.Name:Hide()
	end
	if cfg.unit[unit].Frame.Text.Health.Enabled == false then
		self.TextParent.Health:Hide()
	end
	if cfg.unit[unit].Frame.Text.Power.Enabled == 0 then
		self.TextParent.Power:Hide()
	--elseif cfg.unit[unit].Frame.Text.Power.Enabled == 1 and UnitPower(unit) > 0 then
		-- Don't Force Hide, but don't show 
	--else
		self.TextParent.Power:Show()
	end	
	if cfg.unit[unit].Frame.Text.Level.Enabled == false then
		self.TextParent.Level:Hide()
	end

	local FrameIndex = RUF:UnitToIndex(unit)
	RUF:UpdateHealthBackground(FrameIndex)
end

function RUF:OnEnable()
	cfg = self.db.profile
	oUF:RegisterStyle('RUF_', SetupFrames)
	oUF:Factory(function(self)
		self:SetActiveStyle('RUF_')
		self:Spawn('player'):SetPoint(
			cfg.unit["player"].Frame.Position.AnchorFrom,
			cfg.unit["player"].Frame.Position.AnchorFrame,
			cfg.unit["player"].Frame.Position.AnchorTo,
			cfg.unit["player"].Frame.Position.x,
			cfg.unit["player"].Frame.Position.y)
		self:Spawn('pet'):SetPoint(
			cfg.unit["pet"].Frame.Position.AnchorFrom,
			cfg.unit["pet"].Frame.Position.AnchorFrame,
			cfg.unit["pet"].Frame.Position.AnchorTo,
			cfg.unit["pet"].Frame.Position.x,
			cfg.unit["pet"].Frame.Position.y)
		self:Spawn('focus'):SetPoint(
			cfg.unit["focus"].Frame.Position.AnchorFrom,
			cfg.unit["focus"].Frame.Position.AnchorFrame,
			cfg.unit["focus"].Frame.Position.AnchorTo,
			cfg.unit["focus"].Frame.Position.x,
			cfg.unit["focus"].Frame.Position.y)
		self:Spawn('target'):SetPoint(
			cfg.unit["target"].Frame.Position.AnchorFrom,
			cfg.unit["target"].Frame.Position.AnchorFrame,
			cfg.unit["target"].Frame.Position.AnchorTo,
			cfg.unit["target"].Frame.Position.x,
			cfg.unit["target"].Frame.Position.y)
		self:Spawn('targettarget'):SetPoint(
			cfg.unit["targettarget"].Frame.Position.AnchorFrom,
			cfg.unit["targettarget"].Frame.Position.AnchorFrame,
			cfg.unit["targettarget"].Frame.Position.AnchorTo,
			cfg.unit["targettarget"].Frame.Position.x,
			cfg.unit["targettarget"].Frame.Position.y)
		self:Spawn('pettarget'):SetPoint(
			cfg.unit["pettarget"].Frame.Position.AnchorFrom,
			cfg.unit["pettarget"].Frame.Position.AnchorFrame,
			cfg.unit["pettarget"].Frame.Position.AnchorTo,
			cfg.unit["pettarget"].Frame.Position.x,
			cfg.unit["pettarget"].Frame.Position.y)
		self:Spawn('focustarget'):SetPoint(
			cfg.unit["focustarget"].Frame.Position.AnchorFrom,
			cfg.unit["focustarget"].Frame.Position.AnchorFrame,
			cfg.unit["focustarget"].Frame.Position.AnchorTo,
			cfg.unit["focustarget"].Frame.Position.x,
			cfg.unit["focustarget"].Frame.Position.y)
		if cfg.unit[RUF.db.global.UnitList[15].group].Enabled == true then
			local party = oUF:SpawnHeader(
				'oUF_RUF_Party', nil, 'party',
				'showSolo', false,
				'showParty', true,
				'showRaid', false,
				'showPlayer', false,
				'yOffset', 4,
				'Point', 'BOTTOM'
			):SetPoint(
				cfg.unit["party"].Frame.Position.AnchorFrom,
				cfg.unit["party"].Frame.Position.AnchorFrame,
				cfg.unit["party"].Frame.Position.AnchorTo,
				cfg.unit["party"].Frame.Position.x,
				cfg.unit["party"].Frame.Position.y)
		end
		for index = 1, 4 do
			local boss = self:Spawn('boss' .. index)
			--local bosstarget = self:Spawn('bosstarget' .. index)
			if(index == 1) then
				boss:SetPoint(
					cfg.unit.boss.Frame.Position.AnchorFrom,
					cfg.unit.boss.Frame.Position.AnchorFrame,
					cfg.unit.boss.Frame.Position.AnchorTo,
					cfg.unit.boss.Frame.Position.x,
					cfg.unit.boss.Frame.Position.y)
				--[[bosstarget:SetPoint(
					cfg.unit.bosstarget.Frame.Position.AnchorFrom,
					cfg.unit.bosstarget.Frame.Position.AnchorFrame,
					cfg.unit.bosstarget.Frame.Position.AnchorTo,
					cfg.unit.bosstarget.Frame.Position.x,
					cfg.unit.bosstarget.Frame.Position.y)]]--
			else
				boss:SetPoint('TOP', _G['oUF_RUF_Boss' .. index - 1], 'BOTTOM', 0, -4)
				--bosstarget:SetPoint('TOP', _G['oUF_RUF_BossTarget' .. index - 1], 'BOTTOM', 0, -4)
			end
		end
		for index = 1, 5 do
			local arena = self:Spawn('arena' .. index)
			--local arenatarget = self:Spawn('arenatarget' .. index)
			if(index == 1) then
				arena:SetPoint(
					cfg.unit.arena.Frame.Position.AnchorFrom,
					cfg.unit.arena.Frame.Position.AnchorFrame,
					cfg.unit.arena.Frame.Position.AnchorTo,
					cfg.unit.arena.Frame.Position.x,
					cfg.unit.arena.Frame.Position.y)
				--[[arenatarget:SetPoint(
					cfg.unit.arenatarget.Frame.Position.AnchorFrom,
					cfg.unit.arenatarget.Frame.Position.AnchorFrame,
					cfg.unit.arenatarget.Frame.Position.AnchorTo,
					cfg.unit.arenatarget.Frame.Position.x,
					cfg.unit.arenatarget.Frame.Position.y)]]--
			else
				arena:SetPoint('TOP', _G['oUF_RUF_Arena' .. index - 1], 'BOTTOM', 0, -4) -- TODO: Add Option to change growth direction
				--arenatarget:SetPoint('TOP', _G['oUF_RUF_ArenaTarget' .. index - 1], 'BOTTOM', 0, -4)
			end
		end
	end)

	for i = 1,#RUF.db.global.UnitList do
		if _G[RUF.db.global.UnitList[i].frame] then
			if cfg.unit[RUF.db.global.UnitList[i].name].Enabled == false and not cfg.unit[RUF.db.global.UnitList[i].group] then
				_G[RUF.db.global.UnitList[i].frame]:Disable()
			elseif cfg.unit[RUF.db.global.UnitList[i].name].Enabled == true and not cfg.unit[RUF.db.global.UnitList[i].group]then
				_G[RUF.db.global.UnitList[i].frame]:Enable()
			end
		end
	end
end
